%if 0%{?with_debug}
# https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global repoURL linux-git.us.oracle.com/OLCNE/kubernetes

Name:           kubeadm-ha-setup
# TODO: for future, we can make release as k8s version and version as out HA iteration. In that way we can on support n-1 to n upgrades.
Version:        0.0.2
Release:        1.0.73%{?dist}
ExclusiveArch:  x86_64
Summary:        Oracle Linux kubernetes tool
License:        UPL
Vendor:         Oracle America
Group:          System Environment/Shells
Url:            https://%{repoURL}/%{name}
Source:         %{name}-%{version}.tar.bz2
BuildRequires:  golang >= 1.13.15
# Should be the minimum supported version. (Maybe we don't want this here. But rather always have to script install the version it needs)
Requires:       kubeadm >= 1.12
Requires:       kubelet >= 1.12
Requires:       kubectl >= 1.12
Requires:       keepalived

#%{?systemd_requires}

%description
Oracle Linux kubernetes tool.

This tool help to easily provision kubernetes cluster
utilizing kubeadm.
%prep
%setup -q -n %{name}-%{version}
mkdir -p src/%{repoURL}/%{name}
mv $(ls | grep -v "^src$") src/%{repoURL}/%{name}

%build
export GOPATH=$(pwd)
export GOBIN=$GOPATH/bin
export PATH=$GOBIN:$PATH
cd src/%{repoURL}/%{name}
go build -v

%install
pushd src/%{repoURL}/%{name}
mkdir -p %{buildroot}/usr/local/share/kubeadm/run/kubeadm
mkdir -p %{buildroot}/usr/local/share/kubeadm/kubeadm-ha
install -m 755 -d %{buildroot}/usr/local/share/kubeadm/kubeadm-ha
install -m 755 -d %{buildroot}/usr/local/share/kubeadm/addons/metrics-server
cp -rp addons/metrics-server/* %{buildroot}/usr/local/share/kubeadm/addons/metrics-server/
cp files/*  %{buildroot}/usr/local/share/kubeadm/kubeadm-ha/
install -m 755 -d %{buildroot}%{_bindir}
install -p -m 755 -t %{buildroot}%{_bindir} ./%{name}
popd
mv src/%{repoURL}/%{name}/LICENSE .

%files
%license LICENSE
/usr/local/share/kubeadm/kubeadm-ha/*
%{_bindir}/%{name}
/usr/local/share/kubeadm/run/kubeadm/
/usr/local/share/kubeadm/addons/metrics-server/

%changelog
* Wed Aug 19 2020 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.73
- Fix update to coredns image tag

* Mon Aug 17 2020 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.72
- Address CVE-2020-16845

* Tue Jul 21 2020 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.71
- Fix check image needs upgrade function

* Fri Apr 10 2020 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.70
- Enhance image tag read to depend on kubeadm-registry.sh for CVE release
  CVE-2020-10749: IPv4 only clusters susceptible to MitM attacks via IPv6 rogue router advertisements
  CVE-2020-8555: Half-Blind SSRF in kube-controller-manager

* Wed Apr 08 2020 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.69
- [CVE-2019-11254] kube-apiserver Denial of Service vulnerability from malicious YAML payloads

* Wed Nov 06 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.68
- Pull image prior to update and fix image repo for addons

* Tue Oct 29 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.67
- Bump golang build version

* Tue Oct 29 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.66
- [CVE-2019-16276] Support patching flannel/dashboard on upgrade

* Tue Oct 29 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.65
- [CVE 2019-16276] Support deploygin 1.12 and 1.13 with CVE patched

* Mon Oct 28 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.64
- [CVE-2019-16276] Support patching etcd on upgrade

* Thu Oct 24 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.63
- [CVE-2019-16276] while upgrading a cluster patch the coredns image

* Tue Oct 22 2019 Ivin Sony <ivin.sony@oracle.com> - 0.0.2-1.0.62
- CVE-2019-16276 : Update flannel , etcd coredns and dashboard images.

* Tue Sep 24 2019 Michael Calunod <michael.calunod@oracle.com> - 0.0.2-1.0.61
- Added Support for 1.13.11 and removed support for 1.13.10

* Thu Sep 05 2019 Michael Calunod <michael.calunod@oracle.com> - 0.0.2-1.0.59
- Remove Support for 1.14.6

* Wed Sep 04 2019 Michael Calunod <michael.calunod@oracle.com> - 0.0.2-1.0.58
- Replacing reference to kubernetes-dashboard-amd64 with kubernetes-dashboard

* Tue Aug 27 2019 James McCarthy <james.m.mccarthy@oracle.com> - 0.0.2-1.0.57
- Support 1.12.10

* Mon Aug 26 2019 James McCarthy <james.m.mccarthy@oracle.com> - 0.0.2-1.0.56
- Support 1.14.6

* Thu Aug 22 2019 James McCarthy <james.m.mccarthy@oracle.com> - 0.0.2-1.0.55
- Support 1.13.10

* Tue Aug 13 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.54
- Support 1.13.9

* Mon Jul 08 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.53
- Mark 1.14 as a developer build

* Mon Jul 08 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.52
- Restore fails when trying to restore after a failed update

* Mon Jul 01 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.51
- Minor version update doesn't update kubeadm on all master nodes

* Wed Jun 26 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.50
- Make k8s 1.14 specific changes

* Tue Jun 25 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.49
- Remove 1.10 and 1.11 version since they are incompatable

* Wed Jun 19 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.48
- Support deploying 5 master nodes

* Tue Jun 18 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.47
- Only update/upgrade the controlplane images if they changed in the Release object

* Thu Jun 06 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.46
- Fix version comparison function during upgrade

* Mon Jun 3 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.45
- Fix rpm version compare
- Allow kubernetes updates for patch version

* Fri May 31 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.44
- Allow assume yes to deploy a single master without the prompt

* Thu May 30 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.43
- Post cluster creation should check only for master nodes

* Mon May 20 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.42
- Update keepalived check api server to ensure we are grepping the correct IP

* Mon May 20 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.41
- Make ha.yaml an optional argument in the cli for single master cluster

* Fri May 17 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.40
- Add pod cidr default and refactor ha.yaml example

* Wed May 15 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.39
- Remove features: feature1_13=true from config

* Tue May 14 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.38
- Default kubernetes version to latest production version

* Tue May 14 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.37
- Fix keepalived issue when firewalld is disable

* Tue May 14 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.36
- Default kubernetes version to latest production version

* Mon May 13 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.35
- Add addons template and config files

* Fri May 10 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.34
- Enhance tests

* Thu May 02 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.33
- fix regression of previous firewall fix

* Fri Apr 26 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.32
- Fix firewall issues during restore

* Fri Apr 26 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.31
- Fix firewall issues

* Wed Apr 17 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.30
- Enhance output while validating the system

* Wed Apr 17 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.29
- Fix DR in 1.13

* Mon Apr 15 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.28
- Fix apiserver_cert_extra_sans for 1.13 clusters

* Wed Apr 10 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.27
- Fix update/upgrade output message
* Tue Apr 09 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.26
- Fix major upgrade

* Tue Apr 09 2019 Ivin Sony <ivin.sony@oracle.com> - 0.0.2-1.0.25
- Add registry migration

* Fri Apr 05 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.24
- Return stdout and stderr from Run function to allow the caller decided what to display

* Fri Apr 05 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.23
- Proxy variable is inherited in remote master

* Fri Apr 05 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.22
- The Trim function doesn't work for replacing strings
- Upgrade should use the pause container instead of pause-amd64

* Wed Apr 03 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.21
- Include 1.12.7 image and update 1.13 and metric servers info

* Tue Apr 02 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.20
- Support new registries and allow for password to have a colon

* Thu Mar 28 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.19
- --force flag for full restore

* Wed Mar 27 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.18
- Change update help message

* Tue Mar 26 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.17
- Change update message, add ha install command and ask for confirmation

* Mon Mar 25 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.16
- Change upgrade command name to update

* Tue Mar 05 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.15
- Fix upgrade for point release

* Mon Feb 25 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.14
- Move file.go to config.go

* Tue Feb 19 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.13
- Feature Flag 1.13 code

* Fri Feb 01 2019 Muminul islam <muminul.islam@oracle.com> - 0.0.2-1.0.12
- Add support of upgrading HA master nodes

* Tue Jan 29 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.11
- Support deploying Kubernetes version 1.13.2

* Tue Jan 29 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.10
- CVE-2018-16875

* Mon Jan 28 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.9
- Add timeout to Run() (gitlab issues #3)
- Rename path to linux-git.us.oracle.com/Kubernetes

* Mon Jan 28 2019 Muminul Islam <muminul.islam@oracle.com> - 0.0.2-1.0.8
- Remove releases.json dependency

* Wed Jan 23 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.7
- Pin dependent kubernetes packages

* Thu Jan 10 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.6
- Update deps for kube 1.13

* Tue Jan 08 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.5
- Add test runner in makefile and execute it in CI/CD

* Tue Jan 08 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.4
- Fix backup path issue again found by Tom Cocozzello

* Tue Jan 08 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.3
- [Orabug 29152516] Backup and restore /var/lib/kubelet/kubeadm-flags.env too
- Cleanup kube-ipvs0 interface too
- More code cleanup
- Use map for checking kernel module
- Fix client joining errors
- Addressing Tom Cocozzello's review
- Enabling IPVS in HA

* Mon Jan 07 2019 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.2-1.0.2
- Update dashboard image (CVE-2018-18264)

* Mon Jan 07 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.2-1.0.1
- Allow Oracle certified addons to be installed via cli

* Fri Jan 04 2019 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.1-2.0.9
- Use 'dep ensure' to clean up symlinks in the vendor directory

* Mon Dec 17 2018 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.1-2.0.5
- Clean up un-used build scripts

* Mon Dec 17 2018 Tom Cocozzello <tom.cocozzello@oracle.com> - 0.0.1-2.0.4
- Add Makefile for building and testing code

* Thu Dec 13 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-2.0.3
- Fix file restore issue when it contains "./"

* Thu Dec 13 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-2.0.2
- Resolve the full filepath when "." is passed in
- Addressing review by Muminul Islam

* Thu Dec 13 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-2.0.1
- Remove "firewall-cmd --reload" as it can hangs OCI
- Fix some errors reported by Shubham
- Error out if options is not currently supported in HandleEtcdOps
- Fix down issue
- Dump log output to /var/log/kubeadm-ha-setup

* Fri Dec 07 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.37
- Fix kubernetes version
- Include log printing when error occurs
- Fix client.go regression due to new down function

* Thu Dec 06 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.36
- Remove Godeps, using dep for now
- Check if image is not set before referencing
- Rename getEtcdConfigV2 to getEtcdConfig
- Adding down functionality
- Update ha.yaml file

* Wed Dec 05 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.35
- Removing etcd.go
- Addressing Tom Cocozzello review
- [Orabug 28977571]

* Fri Nov 30 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.34
- Enabling full restore on HA master and single master
- Cleanup
- Enable single master backup
- Double the context request timeout
- Implement retryable AddMember

* Wed Nov 28 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.33
- Modified DR for One node case to use new etcd API
- Enhanced the helper scripts such that it will error out
- HealthCheck re-implementation

* Wed Nov 21 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.32
- Update dashboard image

* Mon Nov 19 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.31
- Needs to be run as a privileged user
- Enable CoreDNS as default

* Thu Nov 15 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.30
- Enable single master setup

* Thu Nov 15 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.29
- Redesigned for setting up v1.12 HA clusters

* Thu Oct 18 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.28
- Fixes for v1.11
- Addressing Laszlo Peter review
- Addressing Daniel Krasinski review

* Thu Sep 20 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.27
- Fix build failure
- Add UPL LICENSE
- Fix the usage of defer
- Re-try when docker pull image gets a timeout
- Refactor SetupCreds()
- Remove --force flag for restore
- When something fail, we should lenghten the timeout time

* Tue Sep 11 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.26
- When context timed out catch it and print stdout, stderr

* Thu Aug 30 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.25
- Check output from docker client and probe for error

* Wed Aug 29 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.24
- Properly parse if repo has a special ":" character

* Wed Aug 29 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.23
- Checking the total nodes would be better implementation
- Fixup etcd add member errors

* Tue Aug 28 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.22
- Pod count could be >= 20
- Remove port 30000-32767/tcp check for client node
- Querying k8s cluster health instead of etcd for backup
- Cosmestic fix
- Etcd one node restore problems

* Mon Aug 27 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.21
- Check whether repo needs auth even in one node restore case
- Fixup the restore script
- docker pull image change in behavior in 18.03
- Include client side image repo checking too
- Provide a full repo path for comparison
- Make kubernetes_developer as the sample repo
- Use strings.Contains to compare strings
- Fix README
- Initial README
- Include changes in kube.go

* Wed Aug 15 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.20
- In OCI LB can takes time to setup properly
- Fix random string
- [Orabug 28445064]
- Replace RunCmdExec() with just Run()
- Sanity check for # of master
- Make kubeadm token default to be random

* Tue Aug 14 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.19
- Check if docker exec etcd returns Error
- Check env first before trying to pull image
- [Orabug 28461826]

* Mon Aug 13 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.18
- Fixing LB, kubelet, kubectl-proxy
- Add a DEBUG flag for more verbose output

* Sat Aug 11 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.17
- Don't loop forever in client, make Run() more consistent in master
- Fixup LB for OCI
- Add apiserver-bind-port capability

* Fri Aug 10 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.17
- Include apiserver_cert_extra_sans and service_cidr

* Thu Aug 09 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.16
- Include restoring keepalived for one and full restore
- For Full Restore we need to first clean up before anything else
- Clean up DR, make backup check etcd health first
- Properly clean-up flannel.1 and cni0

* Wed Aug 08 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.15
- DR code cleanup
- Changed permission on the created dir to 0755
- Fix filename not found error

* Thu Aug 02 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.14
- Don't panic()
- In One node restore case verify the ca.crt MD5SUM
- Full DR feature
- Redesign of the DR
- Include file and its line number for logging
- Put the binary full path
- Re-arrange varibles for ssh.go
- Separate etcd cli to another file (etcd.go)
- Addition to kubectl cli
- Check if MyIP for local node is missing/empty

* Thu Jul 26 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.13
- Replace binary names
- Include the ability to re-try master setup

* Tue Jul 24 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.12
- Renamed the whole REPO to kubeadm-ha-setup
- Don't print out more logs as necessary

* Mon Jul 23 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.12
- Enhance ssh/sftp code

* Fri Jul 20 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.11
- Change the storePath
- Include keepalived backup and change backup.sh/restore.sh

* Thu Jul 12 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.10
- Continuing on the restore part
- Make the script to query all KUBEDIR directory from a single file
- Consolidate KUBEDIR
- Make systemd related file 0644

* Tue Jul 10 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.9
- Fixup the hardcoded directory as such we are reading from only limited source
- Include the Docker API for restore
- Initial implementation of DR

* Fri Jun 22 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.8
- Fixup kubeadm-setup join
- systemctl enable kubelet

* Mon Jun 18 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.7
- Fix LoadBalancer to take care of extra steps

* Fri Jun 15 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.6
- Cleanup some stdout
- Add token field in ha.yaml for ease of automated setup

* Mon Jun 11 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.5
- If Loadbalancer is preferred/used

* Fri Jun 08 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.4
- Remove goroutine sleep - unnecessary
- Provides structure to store required files and cert files
- Fix merge errors

* Tue May 29 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.3
- Create /run/kubeadm w-w/o --skip

* Fri May 25 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.2
- NoHA and LoadBalancer

* Fri May 18 2018 Thomas Tanaka <thomas.tanaka@oracle.com> - 0.0.1-1.0.1
- Initial build
